> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create router

> Create a new router with the specified configuration.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml post /cloud/v1/routers/{project_id}/{region_id}
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-15T06:37:28.230198+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/routers/{project_id}/{region_id}:
    post:
      tags:
        - Routers
      summary: Create router
      description: Create a new router with the specified configuration.
      operationId: RouterViewSet.post
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            description: Project ID
            example: 1
            examples:
              - 1
            title: Project Id
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            description: Region ID
            example: 1
            examples:
              - 1
            title: Region Id
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateRouterSerializer'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TaskIDsSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            task_id_list = client.cloud.networks.routers.create(
                project_id=1,
                region_id=1,
                name="my_wonderful_router",
            )
            print(task_id_list.tasks)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\ttaskIDList, err := client.Cloud.Networks.Routers.New(context.TODO(), cloud.NetworkRouterNewParams{\n\t\tProjectID: gcore.Int(1),\n\t\tRegionID:  gcore.Int(1),\n\t\tName:      \"my_wonderful_router\",\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", taskIDList.Tasks)\n}\n"
components:
  schemas:
    CreateRouterSerializer:
      properties:
        external_gateway_info:
          anyOf:
            - $ref: '#/components/schemas/RouterExternalManualGwSerializer'
            - $ref: '#/components/schemas/RouterExternalDefaultGwSerializer'
            - type: 'null'
          default: null
          description: >-
            External gateway configuration. Use type 'default' to let the
            platform automatically select the external network, or type 'manual'
            to specify a particular external network via `network_id`. If
            omitted, the router is created without an external gateway.
          examples:
            - enable_snat: true
              type: default
          title: External Gateway Info
        interfaces:
          anyOf:
            - items:
                $ref: '#/components/schemas/CreateRouterInterfaceSubnetSerializer'
              type: array
            - type: 'null'
          default: null
          description: List of interfaces to attach to router immediately after creation.
          examples:
            - - subnet_id: 3ed9e2ce-f906-47fb-ba32-c25a3f63df4f
                type: subnet
          title: Interfaces
        name:
          description: name of router
          example: my_wonderful_router
          examples:
            - my_wonderful_router
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        routes:
          anyOf:
            - items:
                $ref: '#/components/schemas/RouteInSerializer'
              type: array
            - type: 'null'
          default: null
          description: List of custom routes.
          examples:
            - - destination: 10.0.3.0/24
                nexthop: 10.0.0.13
          title: Routes
          x-stainless-terraform-configurability: computed_optional
      required:
        - name
      title: CreateRouterSerializer
      type: object
    TaskIDsSerializer:
      properties:
        tasks:
          description: >-
            List of task IDs representing asynchronous operations. Use these IDs
            to monitor operation progress:

            - `GET /v1/tasks/{task_id}` - Check individual task status and
            details

            Poll task status until completion (`FINISHED`/`ERROR`) before
            proceeding with dependent operations.
          example:
            - d478ae29-dedc-4869-82f0-96104425f565
          examples:
            - - d478ae29-dedc-4869-82f0-96104425f565
          items:
            type: string
          title: Tasks
          type: array
      required:
        - tasks
      title: TaskIDsSerializer
      type: object
    RouterExternalManualGwSerializer:
      properties:
        enable_snat:
          default: true
          description: Is SNAT enabled. Defaults to true.
          example: true
          examples:
            - true
          title: Enable Snat
          type: boolean
        network_id:
          description: ID of the external network to connect the router to.
          example: 3d1e9779-b8ad-4c8e-a1a4-0a03671f07f7
          examples:
            - 3d1e9779-b8ad-4c8e-a1a4-0a03671f07f7
          format: uuid4
          title: Network Id
          type: string
          x-stainless-terraform-configurability: computed_optional
        type:
          const: manual
          default: manual
          description: >-
            Gateway type. Use 'manual' to explicitly specify which external
            network the router connects to via `network_id`. Required for
            PATCH/update operations.
          example: manual
          examples:
            - manual
          title: Type
          type: string
      required:
        - network_id
      title: RouterExternalManualGwSerializer
      type: object
    RouterExternalDefaultGwSerializer:
      properties:
        enable_snat:
          default: true
          description: Is SNAT enabled. Defaults to true.
          example: true
          examples:
            - true
          title: Enable Snat
          type: boolean
        type:
          const: default
          default: default
          description: >-
            Gateway type. Use 'default' to let the platform automatically select
            the external network for the router's region. No `network_id` is
            needed. Only valid on create.
          example: default
          examples:
            - default
          title: Type
          type: string
      title: RouterExternalDefaultGwSerializer
      type: object
    CreateRouterInterfaceSubnetSerializer:
      properties:
        subnet_id:
          description: id of the subnet to attach to.
          example: 3d1e9779-b8ad-4c8e-a1a4-0a03671f07f5
          examples:
            - 3d1e9779-b8ad-4c8e-a1a4-0a03671f07f5
          format: uuid4
          title: Subnet Id
          type: string
        type:
          const: subnet
          default: subnet
          description: must be 'subnet'.
          example: subnet
          examples:
            - subnet
          title: Type
          type: string
      required:
        - subnet_id
      title: CreateRouterInterfaceSubnetSerializer
      type: object
    RouteInSerializer:
      properties:
        destination:
          description: CIDR of destination IPv4 or IPv6 subnet.
          example: 10.0.3.0/24
          examples:
            - 10.0.3.0/24
          format: ipvanynetwork
          title: Destination
          type: string
        nexthop:
          description: >-
            IPv4 or IPv6 address to forward traffic to if it's destination IP
            matches 'destination' CIDR.
          example: 10.0.0.13
          examples:
            - 10.0.0.13
          format: ipvanyaddress
          title: Nexthop
          type: string
      required:
        - destination
        - nexthop
      title: RouteInSerializer
      type: object
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````